/**********************************************************************************

 Author        : CAST

 Date          : March 30th, 2011

 File          : ADF7021_IO.h

 Hardware      : ADuC7026 and ADF7021
	
***********************************************************************************/

#define	 N_REGISTER_0		                0
#define  VCO_OSCILLATOR_REGISTER_1          1
#define  TRANSMIT_MODULATION_REGISTER_2     2
#define  TRANSMIT_RECEIVE_CLOCK_REGISTER_3  3 
#define  DEMODULATOR_SETUP_REGISTER_4       4
#define  IF_FILTER_SETUP_REGISTER_5		    5
#define  IF_FINE_CAL_SETUP_REGISTER_6	    6
#define  READBACK_SETUP_REGISTER_7			7
#define  POWER_DOWN_TEST_REGISTER_8			8
#define  AGC_REGISTER_9						9
#define  AFC_REGISTER_10				    10
#define  SYNC_WORD_DETECT_REGISTER_11		11
#define  SWD_THRESHOLD_SETUP_REGISTER_12 	12
#define  FSK_3_4FSK_DEMOD_REGISTER_13		13
#define  TEST_DAC_REGISTER_14				14
#define  TEST_MODE_REGISTER_15 				15


/*********************************************************************************/
/*********       define N_REGISTER_0                      ************************/
#define  BIT_8_INTEGER_N		               44
#define  BIT_15_FRACTIONAL_N_Tx				   5961
#define  BIT_15_FRACTIONAL_N_Rx				   5794

/***  MUXOUT_CONTROL  ***/
#define  REGULATOR_READY			  (0x0<<29)
#define  FILTER_CAL_COMPLETE		  (0x1<<29)
#define  DIGITAL_LOCK_DETECT		  (0x2<<29)
#define  RSSI_READY					  (0x3<<29)
#define  Tx_Rx						  (0x4<<29)
#define  LOGIC_ZERO					  (0x5<<29)
#define  TRISTATE					  (0x6<<29)
#define  OGIC_ONE					  (0x7<<29)

#define  UART_MODE_EN				  (0x1<<28)
#define  TRANSMIT					  (0x0<<27)
#define  RECEIVE					  (0x1<<27)
#define  INTEGER_N			          (BIT_8_INTEGER_N<<19)
#define  FRACTIONAL_N_Tx		          (BIT_15_FRACTIONAL_N_Tx<<4)
#define  FRACTIONAL_N_Rx		          (BIT_15_FRACTIONAL_N_Rx<<4)



/**********************************************************************************/
/*********       define VCO_OSCILLATOR_REGISTER_1      ****************************/
#define	 BIT_4_VCO_BIASCURRENT			   10
#define	 BIT_2_CP_CURRENT				   2
#define	 BIT_2_XTAL_BIAS				   2
#define	 BIT_4_CLOCKOUT_DIVIDE			   0
#define	 BIT_3_R_COUNTER_DIVIDE_RATIO	   1


#define  EXTERNAL_L_VCO				  (0x1<<25)
//VCO CENTER FREQ ADJUST
#define  NOMINAL					  (0x0<<23)
#define  VCO_ADJUST_UP_1			  (0x1<<23)
#define  VCO_ADJUST_UP_2			  (0x2<<23)
#define  VCO_ADJUST_UP_3			  (0x3<<23)
//VCO_BIAS
#define  VCO_BIASCURRENT		      (BIT_4_VCO_BIASCURRENT<<19)
#define  RF_DIVIDE_BY_2				  (0x1<<18)
#define  VCO_LOOP_CONDITION_ON		  (0x1<<17)
#define  CP_CURRENT			          (BIT_2_CP_CURRENT<<15)
#define  XTAL_BIAS			          (BIT_2_XTAL_BIAS<<13)
#define  XOSC_ENABLE				  (0x1<<12)
#define  XTAL_DOUBLER				  (0x1<<11)
#define  CLOCKOUT_DIVIDE		      (BIT_4_CLOCKOUT_DIVIDE<<7)
#define  R_COUNTER_DIVIDE_RATIO       (BIT_3_R_COUNTER_DIVIDE_RATIO<<4)

/**********************************************************************************/
/*********       define TRANSMIT_MODULATION_REGISTER_2     ************************/
#define  BIT_9_Tx_FREQUENCY_DEVIATION	 7
#define  BIT_6_POWER_AMPLIFIER			 46
#define  BIT_2_PA_BIAS					 2
#define  BIT_3_PA_RAMP					 1


#define  RAISED COSINE ALPHA		  (0x1<<30)
//TxDATA INVERT
#define  TxINVERT_NORMAL			  (0x0<<28)
#define  TxINVERT_CLK				  (0x1<<28)
#define  TxINVERT_DATA				  (0x2<<28)
#define  TxINV_CLK_AND_DATA			  (0x3<<28)

#define  Tx_FREQUENCY_DEVIATION       (BIT_9_Tx_FREQUENCY_DEVIATION<<19)
#define  POWER_AMPLIFIER		      (BIT_6_POWER_AMPLIFIER<<13)
#define  PA_BIAS				      (BIT_2_PA_BIAS<<11)
#define  PA_RAMP				      (BIT_3_PA_RAMP<<8)
#define  PA_ENABLE			          (0x1<<7)
//MODULATION_SCHEME
#define  FSK_2						  (0x0<<4)
#define  GAUSSIAN_2FSK				  (0x1<<4)
#define  FSK_3						  (0x2<<4)
#define  FSK_4						  (0x3<<4)
#define  OVERSAMPLED_2FSK			  (0x4<<4)
#define  RAISED_COSINE_2FSK			  (0x5<<4)
#define  RAISED_COSINE_3FSK			  (0x6<<4)
#define  RAISED_COSINE_4FSK			  (0x7<<4)
/**********************************************************************************/
/*********       define  TRANSMIT_RECEIVE_CLOCK_REGISTER_3     ********************/

#define  BIT_6_AGC_CLK_DIVIDE		   10
#define  BIT_8_SEQUENCER_CLK_DIVIDE	   197
#define  BIT_8_CDR_CLK_DIVIDE		   38
#define  BIT_4_DEM_CLK_DIVIDE		   4
#define  BIT_2_BBOS_CLK_DIVIDE		   2


#define  AGC_CLK_DIVIDE				  (BIT_6_AGC_CLK_DIVIDE<<26)
#define  SEQUENCER_CLK_DIVIDE		  (BIT_8_SEQUENCER_CLK_DIVIDE<<18)
#define  CDR_CLK_DIVIDE				  (BIT_8_CDR_CLK_DIVIDE<<10)
#define  DEM_CLK_DIVIDE				  (BIT_4_DEM_CLK_DIVIDE<<6)
#define  BBOS_CLK_DIVIDE			  (BIT_2_BBOS_CLK_DIVIDE<<4)

/***********************************************************************************/
/*********       define  DEMODULATOR_SETUP_REGISTER_4           ********************/

#define  BIT_10_POST_DEMOD_BW		  4
#define  BIT_10_DISCRIMINATOR_BW	  590

//IF_BW
#define  IF_BW_12_5kHz				  (0x0<<30)
#define  IF_BW_18_75kHz				  (0x1<<30)
#define  IF_BW_25kHz				  (0x2<<30)
#define  IF_BW_INVALID				  (0x3<<30)
#define  POST_DEMOD_BW				  (BIT_10_POST_DEMOD_BW<<20)
#define  DISCRIMINATOR_BW			  (BIT_10_DISCRIMINATOR_BW<<10)
//Rx_NVERT
#define  Rx_INVERT_NORMAL			  (0x0<<8)
#define  Rx_INVERT_CLK				  (0x1<<8)
#define  Rx_INVERT_DATA				  (0x2<<8)
#define  Rx_INVERT_CLK_DATA			  (0x3<<8)

#define  DOT_PRODUCT				  (0x1<<7)
//DEMOD_SCHEME
#define  DEMOD_SCHEME_2FSK_LINEAR	  (0x0<<4)
#define  DEMOD_SCHEME_2FSK_CORRELATOR (0x1<<4)
#define  DEMOD_SCHEME_3FSK			  (0x2<<4)
#define  DEMOD_SCHEME_4FSK			  (0x3<<4)

/***********************************************************************************/
/*********       define  IF_FILTER_SETUP_REGISTER_5             ********************/
#define  BIT_5_IR_GAIN_ADJUST_MAG	   0
#define  BIT_4_IR_PHASE_ADJUST_MAG	   0
#define  BIT_6_IF_FILTER_ADJUST		   0
#define  BIT_9_IF_FILTER_DIVIDER	   392

#define  IR_GAIN_ADJUST_UP_DN		   (0x1<<31)
#define  IR_GAIN_ADJUST_Q			   (0x1<<30)
#define  IR_GAIN_ADJUST_MAG			   (BIT_5_IR_GAIN_ADJUST_MAG<<25)
#define  IR_PHASE_ADJUST_Q			   (0x1<<24)
#define  IR_PHASE_ADJUST_MAG		   (BIT_4_IR_PHASE_ADJUST_MAG<<20)
#define  IF_FILTER_ADJUST			   (BIT_6_IF_FILTER_ADJUST<<14)
#define  IF_FILTER_DIVIDER			   (BIT_9_IF_FILTER_DIVIDER<<5)
#define  IF_CAL_COARSE				   (0x1<<4)


/***********************************************************************************/
/*********       define  IF_FINE_CAL_SETUP_REGISTER_6           ********************/
#define  BIT_7_IF_CAL_DWELL_TIME		40
#define  BIT_8_IF_CAL_UPPER_TONE_DIVIDE	75
#define  BIT_8_IF_CAL_LOWER_TONE_DIVIDE	150


#define  IR_CAL_SOURCE_+_2			   (0x1<<30)
//IR CAL SOURCEDRIVE LEVEL
#define  IR_CAL_SOURCEDRIVE_LEVEL_OFF  (0x0<<28)
#define  IR_CAL_SOURCEDRIVE_LEVEL_LOW  (0x1<<28)
#define  IR_CAL_SOURCEDRIVE_LEVEL_MED  (0x2<<28)
#define  IR_CAL_SOURCEDRIVE_LEVEL_HIGH (0x3<<28)

#define  IF_CAL_DWELL_TIME			   (BIT_7_IF_CAL_DWELL_TIME<<21)
#define  IF_CAL_UPPER_TONE_DIVIDE	   (BIT_8_IF_CAL_UPPER_TONE_DIVIDE<<13)
#define  IF_CAL_LOWER_TONE_DIVIDE	   (BIT_8_IF_CAL_LOWER_TONE_DIVIDE<<5)
#define  IF_FINE_CAL				   (0x1<<4)


/***********************************************************************************/
/*********       define  READBACK_SETUP_REGISTER_7              ********************/
#define  READBACK_ENABLED			   (0x1<<8)
//READBACK MODE
#define  AFC_WORD					   (0x0<<6)
#define  ADC_OUTPUT					   (0x1<<6)
#define  FILTER_CAL					   (0x2<<6)
#define  SILICON_RE					   (0x3<<6)
//ADC MODE
#define  MEASURE_RSSI				   (0x0<<4)
#define  BATTERY_VOLTAGE			   (0x1<<4)
#define  TEMP_SENSOR				   (0x2<<4)
#define  TO_EXTERNAL_PIN			   (0x3<<4)
/***********************************************************************************/
/*********       define  POWER_DOWN_TEST_REGISTER_8             ********************/
#define  COUNTER RESET				   (0x1<<15)
#define  CDR_RESET					   (0x1<<14)
#define  DEMOD_RESET				   (0x1<<13)
#define  PA_ENABLE_Rx_MODE			   (0x1<<12)
#define  Tx/Rx_SWITCH_ENABLE		   (0x1<<11)
#define  LOG_AMP_ENABLE				   (0x1<<10)
#define  DEMOD_ENABLE				   (0x1<<9)
#define  ADC_ENABLE					   (0x1<<8)
#define  FILTER_ENABLE				   (0x1<<7)
#define  LNA/MIXER_ENABLE			   (0x1<<6)
#define  SYNTH_ENABLE				   (0x1<<4)
/***********************************************************************************/
/*********       define  AGC_REGISTER_9                         ********************/
#define  BIT_7_AGC_HIGH_THRESHOLD	   70
#define  BIT_7_AGC_LOW_THRESHOLD	   30

#define  MIXER_LINEARITY_HIGH		   (0x1<<28)
#define  LNA_CURRENT				   (0x0<<26)
#define  LNA_MODE_REDUCED GAIN		   (0x1<<25)
#define  FILTER_CURRENT_HIGH		   (0x1<<24)
#define  FILTER_GAIN_8				   (0x0<<22)
#define  FILTER_GAIN_24				   (0x1<<22)
#define  FILTER_GAIN_72				   (0x2<<22)
#define  FILTER_GAIN_INVALID		   (0x3<<22)
#define  LNA_GAIN_3					   (0x0<<20)
#define  LNA_GAIN_10				   (0x1<<20)
#define  LNA_GAIN_30				   (0x2<<20)
#define  LNA_GAIN_INVALID			   (0x3<<20)
//AGC_MODE
#define  AUTO_AGC					   (0x0<<18)
#define  MANUAL_AGC					   (0x1<<18)
#define  FREEZE_AGC					   (0x2<<18)

#define  AGC_HIGH_THRESHOLD			   (BIT_7_AGC_HIGH_THRESHOLD<<11)
#define  AGC_LOW_THRESHOLD			   (BIT_7_AGC_LOW_THRESHOLD<<4)
/***********************************************************************************/
/*********       define  AFC_REGISTER_10                        ********************/
#define  BIT_8_MAX_AFC_RANGE		   50
#define  BIT_3_KP					   4
#define  BIT_4_KI					   11
#define  BIT_12_AFC_SCALING_FACTOR	   426

#define  MAX_AFC_RANGE				   (BIT_8_MAX_AFC_RANGE<<24)
#define  KP							   (BIT_3_KP<<21)
#define  KI							   (BIT_4_KI<<17)
#define  AFC_SCALING_FACTOR			   (BIT_12_AFC_SCALING_FACTOR<<5)
#define  AFC_EN						   (0x1<<4)

/***********************************************************************************/
/*********       define  SYNC_WORD_DETECT_REGISTER_11           ********************/

#define  BIT_24_SYNC_BYTE_SEQUENCE     0xFAAAAE

#define  SYNC_BYTE_SEQUENCE			   (BIT_24_SYNC_BYTE_SEQUENCE<<8)

//MATCHINGTOLERANCE
#define  ACCEPT_0_ERRORS			   (0x0<<6)
#define  ACCEPT_1_ERROR				   (0x1<<6)
#define  ACCEPT_2_ERRORS			   (0x2<<6)
#define  ACCEPT_3_ERRORS			   (0x3<<6)
//SYNC_BYTE_LENGTH
#define  SYNC_12_BITS				   (0x0<<4)
#define  SYNC_16_BITS				   (0x1<<4)
#define  SYNC_20_BITS				   (0x2<<4)
#define  SYNC_24_BITS				   (0x3<<4)
/***********************************************************************************/
/*********       define  SWD_THRESHOLD_SETUP_REGISTER_12        ********************/

#define  BIT_8_DATA_PACKET_LENGTH		1

#define  DATA_PACKET_LENGTH			   (BIT_8_DATA_PACKET_LENGTH<<8)

//SWD MODE
#define  SWD PIN LOW									  (0x0<<6)
#define  SWD_PIN_HIGH_AFTER_NEXT_SYNCWORD				  (0x1<<6)
#define  SWD_HIGH_AFTER_NEXT_SYNCWORD_INTERRUPT_PIN_HIGH  (0x2<<6)
#define  INTERRUPT_PIN_HIGH		                          (0x3<<6)
//LOCK THRESHOLD MODE
#define  THRESHOLD_FREE_RUNNING							  (0x0<<4)
#define  LOCK_THRESHOLD_AFTER_NEXT_SYNCWORD				  (0x1<<4)
#define  LOCK_THRESHOLD_AFTER_NEXT_SYNCWORD_FOR_DATA_PACKET			  (0x2<<4)
#define  LOCK_THRESHOLD			                          (0x3<<4)
/***********************************************************************************/
/*********       define  FSK_3_4FSK_DEMOD_REGISTER_13           ********************/
#define  BIT_4_FSK3_PREAMBLE_TIME_VALIDATE	 0
#define  BIT_7_FSK3_CDR_THRESHOLD			 0
#define  BIT_7_FSK3_FSK4_SLICER_THRESHOLD	 0

#define  FSK3_PREAMBLE_TIME_VALIDATE	(BIT_4_FSK3_PREAMBLE_TIME_VALIDATE<<22)
#define  FSK3_CDR_THRESHOLD				(BIT_7_FSK3_CDR_THRESHOLD<<15)

//VITERBI_PATH_MEMORY
#define  BITS_4_VITERBI_PATH_MEMORY		(0x0<<13)
#define  BITS_6_VITERBI_PATH_MEMORY		(0x1<<13)
#define  BITS_8_VITERBI_PATH_MEMORY		(0x2<<13)
#define  BITS_32_VITERBI_PATH_MEMORY	(0x3<<13)

#define  PHASE_CORRECTION				(0x1<<12)
#define  FSK3_VITERBI_DETECTOR			(0x1<<11)
#define  FSK3_FSK4_SLICER_THRESHOLD		(BIT_7_FSK3_FSK4_SLICER_THRESHOLD<<4)
/***********************************************************************************/
/*********       define  TEST_DAC_REGISTER_14                   ********************/
#define  BIT_3_ED_LEAK_FACTOR			0
#define  BIT_4_TEST_DAC_GAIN			0
#define  BIT_16_TEST_DAC_OFFSET			0


#define  NO_PULSE_EXTENSION				(0x0<<30)
#define  EXTENDED_BY_1					(0x1<<30)
#define  EXTENDED_BY_2					(0x2<<30)
#define  EXTENDED_BY_3					(0x3<<30)
#define  ED_LEAK_FACTOR					(BIT_3_ED_LEAK_FACTOR<<27)
//PULSE_EXTENSION
#define  FULL_RESPONSE_TO_PEAK			(0x0<<25)
#define  RESPONSE_0_5_TO_PEAK			(0x1<<25)
#define  RESPONSE_0_25_TO_PEAK			(0x2<<25)
#define  RESPONSE_0_125_TO_PEAK			(0x3<<25)
#define  TEST_DAC_GAIN					(BIT_4_TEST_DAC_GAIN<<21)
#define  TEST_DAC_OFFSET				(BIT_16_TEST_DAC_OFFSET<<5)
#define  TEST_TDAC_EN					(0x1<<4)
/***********************************************************************************/
/*********       define  TEST_MODE_REGISTER_15                  ********************/
//CAL OVERRIDE
#define  AUTO_CAL						(0x0<<30)
#define  OVERRIDE_GAIN					(0x1<<30)
#define  OVERRIDE_BW					(0x2<<30)
#define  OVERRIDE_BW_AND_GAIN			(0x3<<30)
#define  REG_1_PD						(0x1<<29)
#define  FORCE_LD_HIGH_8				(0x1<<28)
//ANALOG_TEST_MODES
#define  BAND_GAP_VOLTGE				(0x0<<24)
#define  CURRENT_40uA_FROM_REG4			(0x1<<24)
#define  FILTER_I_CHANNEL_STAGE_1		(0x2<<24)
#define  FILTER_I_CHANNEL_STAGE_2		(0x3<<24)
#define  FILTE_I_CHANNEL_STAGE_1		(0x4<<24)
#define  FILTER_Q_CHANNEL_STAGE_1		(0x5<<24)
#define  FILTER_Q_CHANNEL_STAGE_2		(0x6<<24)
#define  FILTE_Q_CHANNEL_STAGE_1		(0x7<<24)
#define  ADC_REFERENCE_VOLTAGE			(0x8<<24)
#define  BIAS_CURRENT_FROM_RSSI_5uA		(0x9<<24)
#define  FILTER_COARSE_CAL_OSCILLATOR_O_P (0xa<<24)
#define  ANALOG_RSSI_I_CHANNEL			(0xb<<24)
#define  OSET_LOOP_VE_FBACK_V_I_CH		(0xc<<24)
#define  SUMMED_O_P_OF_RSSI_RECTIFIER_P	(0xd<<24)
#define  SUMMED_O_P_OF_RSSI_RECTIFIER_N	(0xe<<24)
#define  BIAS_CURRENT_FROM_BB_FILTER	(0xf<<24)
//PLL_TEST_MODES
#define  NORMAL_OPERATION				(0x0<<20)
#define  RDIV							(0x1<<20)
#define  NDIV							(0x2<<20)
#define  RCNTR_2_ON_MUXOUT				(0x3<<20)
#define  NCNTR_2_ON_MUXOUT				(0x4<<20)
#define  ACNTR_TO_MUXOUT				(0x5<<20)
#define  PFD_PUMP_UP_TO_MUXOUT			(0x6<<20)
#define  PFD_PUMP_DN_TO_MUXOUT			(0x7<<20)
#define  SDATA_TO_MUXOUT_OR_SREAD		(0x8<<20)
#define  ANALOG_LOCK_DETECT_ON_MUXOUT	(0x9<<20)
#define  END_OF_COARSE_CAL_ON_MUXOUT	(0xa<<20)
#define  END_OF_FINE_CAL_ON_MUXOUT		(0xb<<20)
#define  FORCE_NEW_PRESCALER_CONFIG_FOR_ALL_N 	 (0xc<<20)
#define  TEST_MUX_SELECTS_DATA			(0xd<<20)
#define  LOCK_DETECT_PERCISION			(0xe<<20)
//#define  RESERVED						(0xf<<20)

//CLK_-MUX
#define  NORMAL_NO_OUTPUT				(0x0<<17)
#define  DEMOD_CLK						(0x1<<17)
#define  CDR_CLK						(0x2<<17)
#define  SEQ_CLK						(0x3<<17)
#define  BB_OFFSET_CLK					(0x4<<17)
#define  SIGMA_DELTA_CLK				(0x5<<17)
#define  ADC_CLK						(0x6<<17)
#define  TxRxCLK						(0x7<<17)
//PFD/CP_TEST_MODES
#define  DEFAULT_NO_BLEED				(0x0<<14)
#define  VE_CONSTANT_BLEED				(0x1<<14)
#define  CVE_CONSTANT_BLEED				(0x2<<14)
#define  CVE_PULSED_BLEED				(0x3<<14)
#define  CVE_PULSE_BLD_DELAY_UP			(0x4<<14)
#define  CPPUMPUP						(0x5<<14)
#define  CPTRI_STATE					(0x6<<14)
#define  CPPUMPDN						(0x7<<14)
//-_TEST_MODES
#define  DEFAULT_3RD_ORDER_SD_NO_DITHER	(0x0<<11)
#define  ST1_ORDER_SD					(0x1<<11)
#define  ND2_ORDER_SD					(0x2<<11)
#define  DITHER_TO_FIRST_STAGE			(0x3<<11)
#define  DITHER_TO_SECOND_STAGE			(0x4<<11)
#define  DITHER_TO_THIRD_STAGE			(0x5<<11)
#define  DITHER_8						(0x6<<11)
#define  DITHER_32						(0x7<<11)
//Tx_TEST_MODES
#define  Tx_CARRIER_ONLY				(0x0<<8)
#define  Tx_PVE_TONE_ONLY				(0x1<<8)
#define  Tx_NVE_TONE_ONLY				(0x2<<8)
#define  Tx_1010_PATTERN				(0x3<<8)
#define  Tx_PN9_DATA_AT_PROGRAMED_RATE	(0x4<<8)
#define  Tx_SYNC_BYTE_REPEATEDLY		(0x5<<8)
#define  NORMAL_OPERAT  				(0x6<<8)
//Rx_TEST_MODES
#define  Rx_TEST_MODES_NORMAL			(0x0<<4)
#define  SCLK_SDATA_I_Q					(0x1<<4)
#define  REVERSE_I_Q					(0x2<<4)
#define  LINEAR_SLICER_ON_RXDATA		(0x3<<4)
#define  CORRELATOR_SLICER_ON_TxRxDATA	(0x4<<4)
#define  ADDITIONAL_FILTERING_ON_I_Q	(0x5<<4)
#define  ENVELOPE_DETECTOR_WATCHDOG_DISABLED   (0x6<<4)
//#define  RESERVED						(0x7<<4)
#define  ENABLE_REG_14_DEMOD_PARAMETERS	(0x8<<4)
#define  PROHIBIT_CALACTIVE				(0x9<<4)
#define  ENABLE_DEMOD_DURING_CAL		(0xa<<4)
#define  FORCE_CALACTIVE				(0xb<<4)
#define  I_Q_TO_TxRxCLK_TxRxDATA		(0xc<<4)
#define  POWER_DOWN_DDT_AND_ED_IN_T_4_MODE	   (0xd<<4)
#define  SDATA_TO_CDR					(0xe<<4)
#define  FSK3_SLICER_ON_TxRxDATA		(0xf<<4)


extern unsigned long int ADF7021Registers[16];

void WriteToADF7021_Registers(unsigned long int *buff , char Adress);
void ADF7021Registers_TRANSMITTER_config(void);
void ADF7021Registers_RECEIVER_config(void);
void TRANSMITTER_GPIO_config(void);
void RECEIVER_GPIO_config(void);

