/***************************************************************************

 Author        : CAST  

 Date          : March 10th, 2011

 File          : ADuC7026Driver.c

 Hardware      : ADuC7026 and ADF7021
	
***************************************************************************/
#include <ADuC7026.h>
#include "ADuC7026Driver.h"

void ADuC7026_Initiate(void)
{
    //Clock Initial
    POWKEY1 = 0x01;				//Start PLL Setting
    POWCON = 0x00;				//Set PLL Active Mode With CD = 0  CPU CLOCK DIVIDER = 41.78MHz
    POWKEY2 = 0xF4;				//Finish PLL Setting
	GP1CON = 0x011;				  //PIN set up for UART
   	//UART InitialBaud Rate = 9600								  	
	COMCON0 = 0x080;  
	COMDIV0 = 0x088;    		
	COMDIV1 = 0x000;
	COMCON0 = 0x007; 
}
void put_char(unsigned char ch)
{          
	COMTX = ch;				 //COMTX is an 8-bit transmit register.
    while(!(0x020==(COMSTA0 & 0x020)))
    {;}
}
void put_string(char *str)
{          
	unsigned int len=0,i;
	while ((str[len] >31)||(str[len]=='\n'))
		len++;
	for (i=0;i<len;i++)
	{
	  put_char(str[i]);
	}
}

void my_delay (int length)
{
	while (length >0)
    	length--;
}

char read_SREAD_data(void)
{
  if ((GP1DAT & 0x04)!=0)	//SREAD=>P1.2
  {
      return(1);
  }
  else
  {
      return(0);
  }
}

char read_TxRxCLK_data(void)
{
  if ((GP1DAT & 0x40)!=0)	//TxRxCLK=>P1.6
  {
      return(1);
  }
  else
  {
      return(0);
  }
}

char read_TxRxDATA_data(void)
{
  if ((GP1DAT & 0x20)!=0)	//TxRxDATA=>P1.5
  {
      return(1);
  }
  else
  {
      return(0);
  }
}
