/***************************************************************************

 Author        : CAST  

 Date          : March 10th, 2011

 File          : ADuC7026Driver.h

 Hardware      : ADuC7026 and ADF7021
	
***************************************************************************/

#define PIN_0  	    ((0x1<<16)<<0)
#define PIN_1  	    ((0x1<<16)<<1)
#define PIN_2  	    ((0x1<<16)<<2)
#define PIN_3  	    ((0x1<<16)<<3)
#define PIN_4  	    ((0x1<<16)<<4)
#define PIN_5  	    ((0x1<<16)<<5)
#define PIN_6  	    ((0x1<<16)<<6)
#define PIN_7  	    ((0x1<<16)<<7)

#define PIN_0_CON  	((0x1<<24)<<0)
#define PIN_1_CON  	((0x1<<24)<<1)
#define PIN_2_CON  	((0x1<<24)<<2)
#define PIN_3_CON  	((0x1<<24)<<3)
#define PIN_4_CON  	((0x1<<24)<<4)
#define PIN_5_CON  	((0x1<<24)<<5)
#define PIN_6_CON  	((0x1<<24)<<6)
#define PIN_7_CON  	((0x1<<24)<<7)



#define SET_SLE_OUT()      	GP4DAT = (GP4DAT | PIN_3_CON);       //P4.3->OUT SLE
#define SET_SCLK_OUT()  	GP1DAT = (GP1DAT | PIN_3_CON);       //P1.3->OUT SCLK
#define SET_SDATA_OUT()	    GP4DAT = (GP4DAT | PIN_5_CON);       //P4.5->OUT SDATA
#define SET_CE_OUT()    	GP4DAT = (GP4DAT | PIN_4_CON);       //P4.4->OUT CE

#define SET_TxRxCLK_OUT()	GP1DAT = (GP1DAT | PIN_6_CON);       //P1.6->OUT TxRxCLK
#define SET_TxRxDATA_OUT()	GP1DAT = (GP1DAT | PIN_5_CON);       //P1.5->OUT TxRxDATA

#define SET_TxRxCLK_IN()	GP1DAT = (GP1DAT & (~PIN_6_CON));       //P1.6->IN TxRxCLK
#define SET_TxRxDATA_IN()	GP1DAT = (GP1DAT & (~PIN_5_CON));       //P1.5->IN TxRxDATA

#define SET_SREAD_IN()  	GP1DAT = (GP1DAT & (~PIN_2_CON));       //P1.2->IN SREAD

#define SET_SWD_IN()  	    GP1CON = (GP1CON & 0xFFFCFFFF);         //P1.4->INT SWD IRQ2


#define SET_SLE()		GP4SET = PIN_3	//P4.3->SLE
#define CLR_SLE()		GP4CLR = PIN_3

#define SET_SCLK()		GP1SET = PIN_3	//P1.3->SCLK
#define CLR_SCLK()		GP1CLR = PIN_3

#define SET_SDATA()	    GP4SET = PIN_5	//P4.5->SDATA
#define CLR_SDATA()		GP4CLR = PIN_5

#define SET_CE()	    GP4SET = PIN_4	//P4.4->CE
#define CLR_CE()		GP4CLR = PIN_4

#define SET_TxRxDATA()	GP1SET = PIN_5	//P1.5->TxRxDATA
#define CLR_TxRxDATA()  GP1CLR = PIN_5

void ADuC7026_Initiate(void);
void put_char(unsigned char ch);
void put_string(char *str);
void my_delay (int length);

char read_SREAD_data(void);
char read_TxRxCLK_data(void);
char read_TxRxDATA_data(void);


