/***************************************************************************

 Author        : CAST

 Date          : March 8th, 2011

 File          : main.c

 Hardware      : ADuC7026 and ADF7021
	
***************************************************************************/
#include <ADuC7026.h>
#include "ADF7021_IO.h"
#include "ADuC7026Driver.h" 

unsigned char buff[30];
unsigned char Receive_Sign = 0;			//Flag for Data Ready
unsigned int Receive_bytes = 0;			//Flag for Data Ready

void sent_char(unsigned char ch);
void sent_string(char *str);
void TRANSMITTER(void);
void RECEIVER(void);

void IRQ_Handler() __irq
{	
    
    unsigned char stop;
	unsigned char temp=0;	
	unsigned char i;	
			//External IRQ3 (IRQ3->INT2 pin of ADXL312)

	Receive_Sign = 1;
	Receive_bytes= 0;
	stop=0;
//	while(read_TxRxCLK_data()==0);
	while(!stop)
	  {
	   	
    	for(i=0; i<8; i++)
	    {
			while(read_TxRxCLK_data()==0);
			temp<<= 1 ;
			temp+=read_TxRxDATA_data();
	        while(read_TxRxCLK_data()==1);		
	    }
	    buff[Receive_bytes]=temp;
	    Receive_bytes++;
	   if(temp==0xFF)
	   {
		 stop=1;
	   }
	  }
	  IRQCLR = IRQCLR|SPM4_IO_BIT;

}


void ADF7021_TRANSMITTER_initial(void)
{
	WriteToADF7021_Registers(ADF7021Registers,4);
	WriteToADF7021_Registers(ADF7021Registers,5);
	WriteToADF7021_Registers(ADF7021Registers,6);
	//WriteToADF7021_Registers(ADF7021Registers,7);
	//WriteToADF7021_Registers(ADF7021Registers,8);
	WriteToADF7021_Registers(ADF7021Registers,9);
	WriteToADF7021_Registers(ADF7021Registers,10);	
	WriteToADF7021_Registers(ADF7021Registers,11);
	WriteToADF7021_Registers(ADF7021Registers,12);
	WriteToADF7021_Registers(ADF7021Registers,13);
	//WriteToADF7021_Registers(ADF7021Registers,14);
	//WriteToADF7021_Registers(ADF7021Registers,15);	
	WriteToADF7021_Registers(ADF7021Registers,1);
	my_delay(1000);	
	WriteToADF7021_Registers(ADF7021Registers,3);
	my_delay(1000);	
	WriteToADF7021_Registers(ADF7021Registers,0);
	my_delay(1000);		
	WriteToADF7021_Registers(ADF7021Registers,2);
	my_delay(10000);
}

void ADF7021_RECEIVER_initial(void)
{	
	WriteToADF7021_Registers(ADF7021Registers,2);	
	//WriteToADF7021_Registers(ADF7021Registers,7);
	//WriteToADF7021_Registers(ADF7021Registers,8);
	WriteToADF7021_Registers(ADF7021Registers,9);	
	WriteToADF7021_Registers(ADF7021Registers,13);
	//WriteToADF7021_Registers(ADF7021Registers,14);
	//WriteToADF7021_Registers(ADF7021Registers,15);
	
	WriteToADF7021_Registers(ADF7021Registers,1);
	my_delay(1000);	
	WriteToADF7021_Registers(ADF7021Registers,3);	
	WriteToADF7021_Registers(ADF7021Registers,6);	
	WriteToADF7021_Registers(ADF7021Registers,5);
	my_delay(1000);   
	WriteToADF7021_Registers(ADF7021Registers,11);
	WriteToADF7021_Registers(ADF7021Registers,12); 
	WriteToADF7021_Registers(ADF7021Registers,0);
	my_delay(1000);  
	WriteToADF7021_Registers(ADF7021Registers,4);
	WriteToADF7021_Registers(ADF7021Registers,10);

}
														
void main (void)
{ 

    ADuC7026_Initiate(); 
	my_delay(1000);
    //TRANSMITTER();
    RECEIVER();

}

void TRANSMITTER(void)
{
    unsigned char buf[3];
	/*     2FSK default   */
	/*				  
    ADF7021Registers[0]=0x1617490;
	ADF7021Registers[1]=0x535011;
	ADF7021Registers[2]=0x3DD082;		
	ADF7021Registers[3]=0x2B149923;
	ADF7021Registers[4]=0x80493814;
	ADF7021Registers[5]=0x3155;			   
	ADF7021Registers[6]=0x50972C6;		   
	ADF7021Registers[7]=0x007;	  
	ADF7021Registers[8]=0x0008;
	ADF7021Registers[9]=0x231E9;
	ADF7021Registers[10]=0x3296354A;				 
	ADF7021Registers[11]=0xFAAAAE3B;		   
	ADF7021Registers[12]=0x0018C;			   
	ADF7021Registers[13]=0x000D;
	ADF7021Registers[14]=0x0000000E;	 			 
	ADF7021Registers[15]=0x0000000F; */

				 
	TRANSMITTER_GPIO_config(); 
	ADF7021Registers_TRANSMITTER_config();	 
										 
	SET_CE();
	my_delay(100000);
	ADF7021_TRANSMITTER_initial();
	put_string("Finish the TRANSMITTER initial \n");
	my_delay(100000);

  while(1)
  {
	buf[0]=0xFA;			
	buf[1]=0xAA;	 	  
	buf[2]=0xAE;
	sent_char(buf[0]);	 	 
	sent_char(buf[1]);			   
	sent_char(buf[2]);			 
    sent_string("I am get the data");
	buf[0]=0xFF;
	sent_char(buf[0]);
	put_string("Finished sentting the data \n");
	my_delay(1000000);
  }	

}
	 
void RECEIVER(void)
{     	
    unsigned char buf[3];
	ADF7021Registers_RECEIVER_config();
	/*     2FSK default   */
  /*				*/			  
	ADF7021Registers[0]=0x9616A20;
	ADF7021Registers[1]=0x535011;
	ADF7021Registers[2]=0x3DD082;		
	ADF7021Registers[3]=0x2B149923;
	ADF7021Registers[4]=0x80493814;
	ADF7021Registers[5]=0x3155;			   
	ADF7021Registers[6]=0x50972C6;		   
	ADF7021Registers[7]=0x007;	  
	ADF7021Registers[8]=0x0008;
	ADF7021Registers[9]=0x231E9;
	ADF7021Registers[10]=0x3296354A;				 
	ADF7021Registers[11]=0xFAAAAE3B;		   
	ADF7021Registers[12]=0x0018C;			   
	ADF7021Registers[13]=0x000D;
	ADF7021Registers[14]=0x0000000E;
	ADF7021Registers[15]=0x0000000F; 	   

		
   	RECEIVER_GPIO_config();

	SET_CE();
	my_delay(100);
	ADF7021_RECEIVER_initial();
	put_string("Finish the RECEIVER initial \n");
	my_delay(10000);
	IRQEN = SPM4_IO_BIT ;	//Enable IRQ1 Interrupt 
	while(1)
	{
		   	if(1 == Receive_Sign)
			{
				unsigned char i;
				Receive_Sign = 0;
				put_string("The received data:");
			    for(i=0;i<Receive_bytes-1;i++)
				{
				   put_char(buff[i]);

				}
		   		put_char('\n');
	            my_delay(100000);
				put_string("The number of receive data: ");
				buf[2]=(Receive_bytes%10)+48;
				Receive_bytes=Receive_bytes/10;
		        buf[1]=(Receive_bytes%10)+48;
				Receive_bytes=Receive_bytes/10;
		        buf[0]=(Receive_bytes%10)+48;
		        put_char(buf[0]);
				put_char(buf[1]);
		        put_char(buf[2]);
		        put_char('\n');
	            my_delay(10000000);

		        IRQEN = SPM4_IO_BIT;
 
		   }

	}
}
void sent_char(unsigned char ch)
{          
	unsigned char temp,i;
	temp = ch;
	for(i=0;i<8;i++)
	{	
		while(read_TxRxCLK_data()==1)
        {;}
		my_delay(1);
	   	if(temp & 0x80)
		{
				SET_TxRxDATA();	  
		}
		else
		{
				CLR_TxRxDATA();	
		}
		temp<<=1;
		while(read_TxRxCLK_data()==0)
		{;}
	}

}
void sent_string(char *str)
{          
	unsigned int len=0,i;
	while ((str[len] >31)||(str[len]=='\n'))
		len++;
	for (i=0;i<len;i++)
	{
	  sent_char(str[i]);
	}
}